=== modified file 'configure.ac'
--- configure.ac	2008-10-08 21:47:58 +0000
+++ configure.ac	2008-10-09 22:38:27 +0000
@@ -28,7 +28,7 @@
 AC_SUBST(CXXLDFLAGS)
 
 AC_CANONICAL_TARGET
-AM_INIT_AUTOMAKE(-Wall -Werror)
+AM_INIT_AUTOMAKE(-Wall -Wno-portability -Werror)
 
 PROTOCOL_VERSION=10
 DOT_FRM_VERSION=6
@@ -1469,6 +1469,9 @@
 esac
 AC_SUBST(MAKE_BINARY_DISTRIBUTION_OPTIONS)
 
+dnl GCC Precompiled Header Support
+AM_CONDITIONAL([GCC_PCH],[test "x$GCC" = "xyes"])
+
 AC_CONFIG_FILES(Makefile extra/Makefile mysys/Makefile dnl
  mystrings/Makefile storage/Makefile dnl
  vio/Makefile po/Makefile.in dnl
@@ -1477,6 +1480,7 @@
  drizzled/field/Makefile dnl
  drizzled/serialize/Makefile dnl
  drizzled/functions/Makefile dnl
+ drizzled/util/Makefile dnl
  drizzled/sql_builtin.cc dnl
  support-files/Makefile dnl
  tests/Makefile tests/install_test_db dnl

=== modified file 'drizzled/Makefile.am'
--- drizzled/Makefile.am	2008-10-08 00:14:19 +0000
+++ drizzled/Makefile.am	2008-10-09 22:38:27 +0000
@@ -1,19 +1,17 @@
-# Copyright (C) 2000-2006 MySQL AB
-# 
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; version 2 of the License.
-# 
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-# 
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-#called from the top level Makefile
+#  Copyright (C) 2008 Sun Microsystems
+# 
+#  This program is free software; you can redistribute it and/or modify
+#  it under the terms of the GNU General Public License as published by
+#  the Free Software Foundation; version 2 of the License.
+#
+#  This program is distributed in the hope that it will be useful,
+#  but WITHOUT ANY WARRANTY; without even the implied warranty of
+#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+#  GNU General Public License for more details.
+#
+#  You should have received a copy of the GNU General Public License
+#  along with this program; if not, write to the Free Software
+#  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 
 MYSQLDATAdir =$(localstatedir)
 
@@ -25,7 +23,7 @@
 
 pkgplugindir =$(pkglibdir)/plugin
 
-SUBDIRS = field serialize functions .
+SUBDIRS = util field serialize functions .
 
 sbin_PROGRAMS =drizzled
 
@@ -147,7 +145,7 @@
 		 order.h \
 		 filesort_info.h \
 		 field_iterator.h \
-		 common_includes.h 
+		 common_includes.h
 
 drizzled_SOURCES = \
 		   sql_db.cc \
@@ -250,12 +248,19 @@
       -DLOCALEDIR=\"$(localedir)\" \
       @DEFS@
 
+if GCC_PCH
+PCHHEADERS =
+else
+PCHHEADERS =
+endif
+
 BUILT_MAINT_SRC = sql_yacc.cc \
 		  sql_yacc.h
 
 BUILT_SOURCES = $(BUILT_MAINT_SRC) \
 		lex_hash.h \
-		version.h
+		version.h \
+		$(PCHHEADERS)
 
 EXTRA_DIST = $(BUILT_MAINT_SRC) \
 	     drizzledumpslow \
@@ -292,6 +297,11 @@
 	sed "s/#include <unistd.h>//g" probes.h.bak > probes.h
 	rm probes.h.bak
 
+if GCC_PCH
+%.h.gch: %.h
+	$(CXXCOMPILE) -include config.h -c $<
+endif
+
 SUFFIXES = .d
 
 .d.o : $(DTRACEFILES)

=== modified file 'drizzled/global.h'
--- drizzled/global.h	2008-10-08 01:52:54 +0000
+++ drizzled/global.h	2008-10-09 22:38:27 +0000
@@ -121,22 +121,6 @@
 extern char _dig_vec_upper[];
 extern char _dig_vec_lower[];
 
-#if defined(__cplusplus)
-template <class T>
-inline bool test(const T a)
-{
-  return a ? true : false;
-}
-template <class T, class U>
-inline bool test_all_bits(const T a, const U b)
-{
-  return ((a & b) == b);
-}
-#else
-#define test(a)    ((a) ? 1 : 0)
-#define test_all_bits(a,b) (((a) & (b)) == (b))
-#endif
-
 #define set_if_bigger(a,b)  do { if ((a) < (b)) (a)=(b); } while(0)
 
 #define set_if_smaller(a,b) do { if ((a) > (b)) (a)=(b); } while(0)

=== modified file 'drizzled/sql_bitmap.h'
--- drizzled/sql_bitmap.h	2008-10-06 06:47:29 +0000
+++ drizzled/sql_bitmap.h	2008-10-09 22:38:27 +0000
@@ -26,7 +26,10 @@
   also be able to use 32 or 64 bits bitmaps very efficiently
 */
 
+/// TODO: OMG FIX THIS
+
 #include <mysys/my_bitmap.h>
+#include <drizzled/util/test.h>
 
 template <uint32_t default_width> class Bitmap
 {

=== modified file 'drizzled/sql_select.cc'
--- drizzled/sql_select.cc	2008-10-07 19:30:18 +0000
+++ drizzled/sql_select.cc	2008-10-09 22:38:27 +0000
@@ -30,6 +30,7 @@
 #include <mysys/my_bit.h>
 #include <drizzled/drizzled_error_messages.h>
 #include <libdrizzle/gettext.h>
+#include <drizzled/util/test.h>
 
 const char *join_type_str[]={ "UNKNOWN","system","const","eq_ref","ref",
 			      "MAYBE_REF","ALL","range","index",

=== modified file 'drizzled/time.cc'
--- drizzled/time.cc	2008-10-06 06:47:29 +0000
+++ drizzled/time.cc	2008-10-09 22:38:27 +0000
@@ -18,6 +18,7 @@
 
 #include <drizzled/server_includes.h>
 #include <drizzled/drizzled_error_messages.h>
+#include <drizzled/util/test.h>
 
 
 	/* Some functions to calculate dates */

=== added directory 'drizzled/util'
=== added file 'drizzled/util/Makefile.am'
--- drizzled/util/Makefile.am	1970-01-01 00:00:00 +0000
+++ drizzled/util/Makefile.am	2008-10-09 22:38:27 +0000
@@ -0,0 +1,30 @@
+#  Copyright (C) 2008 Sun Microsystems
+# 
+#  This program is free software; you can redistribute it and/or modify
+#  it under the terms of the GNU General Public License as published by
+#  the Free Software Foundation; version 2 of the License.
+#
+#  This program is distributed in the hope that it will be useful,
+#  but WITHOUT ANY WARRANTY; without even the implied warranty of
+#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+#  GNU General Public License for more details.
+#
+#  You should have received a copy of the GNU General Public License
+#  along with this program; if not, write to the Free Software
+#  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+
+noinst_HEADERS = convert.h \
+                 test.h
+
+if GCC_PCH
+# Trick automake into producing CXXCOMPILE var. Won't be needed once we
+# have real CXX files in here
+lib_LTLIBRARIES = libutil.la
+libutil_la_SOURCES = dummy.cc
+
+BUILT_SOURCES = convert.h.gch \
+                test.h.gch
+
+%.h.gch: %.h
+	$(CXXCOMPILE) -include config.h -c $<
+endif 

=== added file 'drizzled/util/convert.h'
--- drizzled/util/convert.h	1970-01-01 00:00:00 +0000
+++ drizzled/util/convert.h	2008-10-09 22:38:27 +0000
@@ -0,0 +1,44 @@
+/* - mode: c++; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+ *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+ *
+ *  Copyright (C) 2008 MySQL
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ */
+
+#ifndef DRIZZLE_SERVER_UTIL_CONVERT
+#define DRIZZLE_SERVER_UTIL_CONVERT
+
+#include <string>
+#include <iostream>
+#include <sstream>
+
+template <class T>
+std::string to_string(T t)
+{
+  std::ostringstream o;
+  o << t;
+  return o.str();
+}
+
+template <class T>
+std::string& to_string(std::string &str, T t)
+{
+  std::ostringstream o(str);
+  o << t;
+  return str;
+}
+
+#endif

=== added file 'drizzled/util/dummy.cc'
=== added file 'drizzled/util/test.h'
--- drizzled/util/test.h	1970-01-01 00:00:00 +0000
+++ drizzled/util/test.h	2008-10-09 22:38:27 +0000
@@ -0,0 +1,43 @@
+/* - mode: c++; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+ *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+ *
+ *  Copyright (C) 2008 Sun Microsystems
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ */
+
+#ifndef DRIZZLE_SERVER_UTIL_TEST
+#define DRIZZLE_SERVER_UTIL_TEST
+
+#if defined(__cplusplus)
+
+template <class T>
+inline bool test(const T a)
+{
+  return a ? true : false;
+}
+
+template <class T, class U>
+inline bool test_all_bits(const T a, const U b)
+{
+  return ((a & b) == b);
+}
+
+#else
+# define test(a)    ((a) ? 1 : 0)
+# define test_all_bits(a,b) (((a) & (b)) == (b))
+#endif
+
+#endif

=== modified file 'mystrings/decimal.c'
--- mystrings/decimal.c	2008-10-06 05:57:49 +0000
+++ mystrings/decimal.c	2008-10-09 22:38:27 +0000
@@ -104,6 +104,7 @@
 #include <storage/myisam/myisampack.h>
 #include <mystrings/decimal.h>
 
+#include <drizzled/util/test.h>
 /*
   Internally decimal numbers are stored base 10^9 (see DIG_BASE below)
   So one variable of type decimal_digit_t is limited:

=== modified file 'mysys/mf_iocache.c'
--- mysys/mf_iocache.c	2008-10-07 22:29:30 +0000
+++ mysys/mf_iocache.c	2008-10-09 22:38:27 +0000
@@ -56,7 +56,7 @@
 #endif
 #include <mysys/iocache.h>
 #include <errno.h>
-
+#include <drizzled/util/test.h>
 #define lock_append_buffer(info) \
  pthread_mutex_lock(&(info)->append_buffer_lock)
 #define unlock_append_buffer(info) \

=== modified file 'mysys/my_copy.c'
--- mysys/my_copy.c	2008-10-06 06:47:29 +0000
+++ mysys/my_copy.c	2008-10-09 22:38:27 +0000
@@ -28,6 +28,7 @@
 };
 #endif
 
+#include <drizzled/util/test.h>
 
 /*
   int my_copy(const char *from, const char *to, myf MyFlags)

=== modified file 'mysys/my_getwd.c'
--- mysys/my_getwd.c	2008-10-04 18:42:30 +0000
+++ mysys/my_getwd.c	2008-10-09 22:38:27 +0000
@@ -22,6 +22,7 @@
 #ifdef HAVE_GETWD
 #include <sys/param.h>
 #endif
+#include <drizzled/util/test.h>
 
 /* Gets current working directory in buff.
 

=== modified file 'mysys/my_time.c'
--- mysys/my_time.c	2008-10-06 06:47:29 +0000
+++ mysys/my_time.c	2008-10-09 22:38:27 +0000
@@ -16,6 +16,7 @@
 #include <my_time.h>
 #include <mystrings/m_string.h>
 #include <mystrings/m_ctype.h>
+#include <drizzled/util/test.h>
 /* Windows version of localtime_r() is declared in my_ptrhead.h */
 
 uint64_t log_10_int[20]=

=== modified file 'mysys/thr_lock.c'
--- mysys/thr_lock.c	2008-10-07 00:16:06 +0000
+++ mysys/thr_lock.c	2008-10-09 22:38:27 +0000
@@ -87,6 +87,7 @@
 # endif
 #endif  
 
+#include <drizzled/util/test.h>
 
 bool thr_lock_inited=0;
 uint32_t locks_immediate = 0L, locks_waited = 0L;

=== modified file 'storage/heap/hp_hash.c'
--- storage/heap/hp_hash.c	2008-10-06 06:47:29 +0000
+++ storage/heap/hp_hash.c	2008-10-09 22:38:27 +0000
@@ -17,7 +17,7 @@
 
 #include "heapdef.h"
 #include <mystrings/m_ctype.h>
-
+#include <drizzled/util/test.h>
 
 
 /*

=== modified file 'storage/myisam/ha_myisam.cc'
--- storage/myisam/ha_myisam.cc	2008-10-08 01:10:45 +0000
+++ storage/myisam/ha_myisam.cc	2008-10-09 22:38:27 +0000
@@ -23,6 +23,7 @@
 #include "ha_myisam.h"
 #include "myisamdef.h"
 #include <drizzled/drizzled_error_messages.h>
+#include <drizzled/util/test.h>
 
 ulong myisam_recover_options= HA_RECOVER_NONE;
 

=== modified file 'storage/myisam/mi_check.c'
--- storage/myisam/mi_check.c	2008-10-07 22:29:30 +0000
+++ storage/myisam/mi_check.c	2008-10-09 22:38:27 +0000
@@ -52,6 +52,8 @@
 #ifdef HAVE_SYS_MMAN_H
 #include <sys/mman.h>
 #endif
+#include <drizzled/util/test.h>
+
 
 /* Functions defined in this file */
 

=== modified file 'storage/myisam/mi_create.c'
--- storage/myisam/mi_create.c	2008-10-06 06:47:29 +0000
+++ storage/myisam/mi_create.c	2008-10-09 22:38:27 +0000
@@ -20,6 +20,7 @@
 #include <mysys/queues.h>
 #include <mysys/my_bit.h>
 
+#include <drizzled/util/test.h>
 
 /*
   Old options is used when recreating database, from myisamchk

=== modified file 'storage/myisam/mi_delete.c'
--- storage/myisam/mi_delete.c	2008-10-06 06:47:29 +0000
+++ storage/myisam/mi_delete.c	2008-10-09 22:38:27 +0000
@@ -16,6 +16,7 @@
 /* Remove a row from a MyISAM table */
 
 #include "myisamdef.h"
+#include <drizzled/util/test.h>
 
 static int d_search(MI_INFO *info,MI_KEYDEF *keyinfo,uint32_t comp_flag,
                     unsigned char *key,uint32_t key_length,my_off_t page,unsigned char *anc_buff);

=== modified file 'storage/myisam/mi_dynrec.c'
--- storage/myisam/mi_dynrec.c	2008-10-06 06:47:29 +0000
+++ storage/myisam/mi_dynrec.c	2008-10-09 22:38:27 +0000
@@ -31,6 +31,7 @@
 #ifdef HAVE_SYS_MMAN_H
 #include <sys/mman.h>
 #endif
+#include <drizzled/util/test.h>
 
 /* Enough for comparing if number is zero */
 static char zero_string[]={0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};

=== modified file 'storage/myisam/mi_extra.c'
--- storage/myisam/mi_extra.c	2008-10-06 06:47:29 +0000
+++ storage/myisam/mi_extra.c	2008-10-09 22:38:27 +0000
@@ -17,6 +17,7 @@
 #ifdef HAVE_SYS_MMAN_H
 #include <sys/mman.h>
 #endif
+#include <drizzled/util/test.h>
 
 static void mi_extra_keyflag(MI_INFO *info, enum ha_extra_function function);
 

=== modified file 'storage/myisam/mi_locking.c'
--- storage/myisam/mi_locking.c	2008-10-06 06:47:29 +0000
+++ storage/myisam/mi_locking.c	2008-10-09 22:38:27 +0000
@@ -24,6 +24,7 @@
 #include <mystrings/m_ctype.h>
 #include <mysys/my_tree.h>
 #include <mysys/queues.h>
+#include <drizzled/util/test.h>
 
 	/* lock table by F_UNLCK, F_RDLCK or F_WRLCK */
 

=== modified file 'storage/myisam/mi_open.c'
--- storage/myisam/mi_open.c	2008-10-07 22:29:30 +0000
+++ storage/myisam/mi_open.c	2008-10-09 22:38:27 +0000
@@ -17,6 +17,7 @@
 
 #include "myisamdef.h"
 #include <mystrings/m_ctype.h>
+#include <drizzled/util/test.h>
 
 static void setup_key_functions(MI_KEYDEF *keyinfo);
 #define get_next_element(to,pos,size) \

=== modified file 'storage/myisam/mi_preload.c'
--- storage/myisam/mi_preload.c	2008-10-06 06:47:29 +0000
+++ storage/myisam/mi_preload.c	2008-10-09 22:38:27 +0000
@@ -18,6 +18,8 @@
 */
 
 #include "myisamdef.h"
+#include <drizzled/util/test.h>
+
 
 
 /*

=== modified file 'storage/myisam/mi_rsame.c'
--- storage/myisam/mi_rsame.c	2008-10-06 05:57:49 +0000
+++ storage/myisam/mi_rsame.c	2008-10-09 22:38:27 +0000
@@ -14,6 +14,8 @@
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */
 
 #include "myisamdef.h"
+#include <drizzled/util/test.h>
+
 
 	/*
 	** Find current row with read on position or read on key

=== modified file 'storage/myisam/mi_rsamepos.c'
--- storage/myisam/mi_rsamepos.c	2008-10-06 05:57:49 +0000
+++ storage/myisam/mi_rsamepos.c	2008-10-09 22:38:27 +0000
@@ -17,6 +17,8 @@
 /* As mi_rsame but supply a position */
 
 #include "myisamdef.h"
+#include <drizzled/util/test.h>
+
 
 
 	/*

=== modified file 'storage/myisam/mi_search.c'
--- storage/myisam/mi_search.c	2008-10-06 06:47:29 +0000
+++ storage/myisam/mi_search.c	2008-10-09 22:38:27 +0000
@@ -17,6 +17,7 @@
 
 #include "myisamdef.h"
 #include <mystrings/m_ctype.h>
+#include <drizzled/util/test.h>
 
 static bool _mi_get_prev_key(MI_INFO *info, MI_KEYDEF *keyinfo, unsigned char *page,
                                 unsigned char *key, unsigned char *keypos,

=== modified file 'storage/myisam/mi_update.c'
--- storage/myisam/mi_update.c	2008-10-06 06:47:29 +0000
+++ storage/myisam/mi_update.c	2008-10-09 22:38:27 +0000
@@ -16,6 +16,7 @@
 /* Update an old row in a MyISAM table */
 
 #include "myisamdef.h"
+#include <drizzled/util/test.h>
 
 int mi_update(register MI_INFO *info, const unsigned char *oldrec, unsigned char *newrec)
 {

=== modified file 'storage/myisam/mi_write.c'
--- storage/myisam/mi_write.c	2008-10-06 06:47:29 +0000
+++ storage/myisam/mi_write.c	2008-10-09 22:38:27 +0000
@@ -16,6 +16,8 @@
 /* Write a row to a MyISAM table */
 
 #include "myisamdef.h"
+#include <drizzled/util/test.h>
+
 
 #define MAX_POINTER_LENGTH 8
 

=== modified file 'storage/myisam/myisamchk.c'
--- storage/myisam/myisamchk.c	2008-10-07 22:29:30 +0000
+++ storage/myisam/myisamchk.c	2008-10-09 22:38:27 +0000
@@ -29,6 +29,8 @@
 #ifdef HAVE_SYS_MMAN_H
 #include <sys/mman.h>
 #endif
+#include <drizzled/util/test.h>
+
 
 #define my_raid_create(A,B,C,D,E,F,G) my_create(A,B,C,G)
 #define my_raid_delete(A,B,C) my_delete(A,B)

=== modified file 'vio/viosocket.c'
--- vio/viosocket.c	2008-10-06 05:57:49 +0000
+++ vio/viosocket.c	2008-10-09 22:38:27 +0000
@@ -22,6 +22,7 @@
 
 #include "vio_priv.h"
 #include <sys/socket.h>
+#include <drizzled/util/test.h>
 
 int vio_errno(Vio *vio __attribute__((unused)))
 {

